<?php
class classe_collection {
    private $type;
    private $modele;
    private $contenu;
    private $form;
    private $hydrate;
    public $fichier;
    public $fichier_seul;
    public $messages;


    public function __construct($modele){
        $this->modele=$modele;
        $structure=json_decode(json_encode((array)simplexml_load_file($modele)),1);
        // nettoyage de l'attribut du tag de base après récupération du type
        $this->type=$structure['@attributes']['type'];
        // dupliquer la structure dans le contenu
        $this->contenu=$structure;
        unset($this->contenu['@attributes']);
        foreach($this->contenu as $cle => $valeur){
            $this->contenu[$cle]['contenu']="";
        }
        $this->hydrate=false;
        $message=array();

        //print_r($this->contenu);
    }

    // fonction de lecture d'un xml
    // reçoit le nom, et va récupérer
    // le xml grace à la constante d'adresse du dossier
    // dans le fichier de configuration
    public function lire_xml($fichier){
        $this->fichier=$fichier;
        $this->fichier_seul=fichier_seul($fichier);
        $tempcontenu=json_decode(json_encode((array)simplexml_load_file($fichier)),1);
        unset($tempcontenu['@attributes']);
        // transformation éventuelle de l'array pour complaire à la structure

        // hydrater la structure par le contenu
        foreach($this->contenu as $cle => $valeur){
            if(isset($tempcontenu[$cle])){
                $this->contenu[$cle]['contenu']=$tempcontenu[$cle];
                // supprimer cette clé du contenu
                // pour pouvoir dans un deuxième temps
                // ajouter les contenus éventuellement ajoutés librement 
                // sans référence dans la définition du xml
                unset($tempcontenu[$cle]);
            } else {
                $this->contenu[$cle]['contenu']="";
            }
        }

        // ajouter les champs trouvé hors définition dans le contenu
        // par exemple <truc>contenu du truc</truc>
        foreach($tempcontenu as $cle => $valeur){
            $this->contenu[$cle]['@attributes']['type']='unknow';
            $this->contenu[$cle]['@attributes']['titre']=$cle;
            if(is_array($tempcontenu[$cle])){
                foreach($tempcontenu[$cle] as $ar_item){
                    $this->contenu[$cle]['contenu'][]=$ar_item;
                }
            } else {
                $this->contenu[$cle]['contenu']=$tempcontenu[$cle];
            }
        }
        $this->hydrate=true;

    }

    //sur base de la structure de $contenu, écrit le formulaire
    public function ecrit_xml(){
        $doc = new DOMDocument();
        $doc->formatOutput = true;
        $doc->encoding = "UTF-8";
        $item = $doc->createElement('item');
        $item->setAttribute('type', $this->type);

        foreach($this->contenu as $tag => $contenu){
            // print_r($contenu);

            if(is_array($contenu['contenu'])){
                // type "multiple", prendre chaque item pour le rentrer

                foreach($contenu['contenu'] as $e){
                    $elem = $doc->createElement( $tag );
                    $elem->appendChild( $doc->createTextNode($e) );
                    $item->appendChild( $elem );
                }

            } else {
                // contenu unique, créer un noeud
                if($contenu['contenu']!=""){
                    $elem = $doc->createElement( $tag );
                    $elem->appendChild(
                        $doc->createTextNode( $contenu['contenu'] )
                    );
                    $item->appendChild( $elem );
                }
            }
        }
        $doc->appendChild( $item );

        fix_exists_dir(CHEMIN.DOSSIER_XML);
        $doc->save($this->fichier);

    }

}
?>