<?php
class classe_xml {
    private $type;
    private $modele;
    private $contenu;
    private $form;
    private $hydrate;
    public $fichier;
    public $fichier_seul;
    public $cle;
    public $messages; 

    public function __construct($modele){
        $this->modele=$modele;
        $structure=json_decode(json_encode((array)simplexml_load_file($modele)),1);
        // nettoyage de l'attribut du tag de base après récupération du type
        $this->type=$structure['@attributes']['type'];
        // la cle de tri est l'attribut de cle, sinon le premier tag de type texte
        $this->cle=$structure['@attributes']['cle'];
        // dupliquer la structure dans le contenu
        $this->contenu=$structure;
        unset($this->contenu['@attributes']);
        foreach($this->contenu as $cle => $valeur){
            if(empty($this->cle) && $valeur['@attributes']['type']=="text"){
                $this->cle =$cle;
            }
            $this->contenu[$cle]['contenu']="";
        }
        $this->hydrate=false;
        $message=array();

        //print_r($this->contenu);
    }

    // fonction de lecture d'un xml
    // reçoit le nom, et va récupérer
    // le xml grace à la constante d'adresse du dossier
    // dans le fichier de configuration
    public function lire_xml($fichier){
        $this->fichier=$fichier;
        $this->fichier_seul=fichier_seul($fichier);
        $tempcontenu=json_decode(json_encode((array)simplexml_load_file($fichier,'SimpleXMLElement', LIBXML_NOCDATA)),1);
        
        unset($tempcontenu['@attributes']);
        // transformation éventuelle de l'array pour complaire à la structure

        // hydrater la structure par le contenu
        foreach($this->contenu as $cle => $valeur){
            if(isset($tempcontenu[$cle])){
                $this->contenu[$cle]['contenu']=$tempcontenu[$cle];
                // supprimer cette clé du contenu
                // pour pouvoir dans un deuxième temps
                // ajouter les contenus éventuellement ajoutés librement 
                // sans référence dans la définition du xml
                unset($tempcontenu[$cle]);
            } else {
                $this->contenu[$cle]['contenu']="";
            }
        }

        // ajouter les champs trouvé hors définition dans le contenu
        // par exemple <truc>contenu du truc</truc>
        foreach($tempcontenu as $cle => $valeur){
            $this->contenu[$cle]['@attributes']['type']='unknow';
            $this->contenu[$cle]['@attributes']['titre']=$cle;
            if(is_array($tempcontenu[$cle])){
                foreach($tempcontenu[$cle] as $ar_item){
                    $this->contenu[$cle]['contenu'][]=$ar_item;
                }
            } else {
                $this->contenu[$cle]['contenu']=$tempcontenu[$cle];
            }
        }
        $this->hydrate=true;

    }

    //sur base de la structure de $contenu, écrit le formulaire
    public function ecrit_xml(){
        $doc = new DOMDocument();
        $doc->formatOutput = true;
        $doc->encoding = "UTF-8";
        $item = $doc->createElement('item');
        $item->setAttribute('type', $this->type);

        foreach($this->contenu as $tag => $contenu){
            // print_r($contenu);

            if(is_array($contenu['contenu'])){
                // type "multiple", prendre chaque item pour le rentrer

                foreach($contenu['contenu'] as $e){
                    $elem = $doc->createElement( $tag );
                    $elem->appendChild( $doc->createTextNode($e) );
                    $item->appendChild( $elem );
                }

            } else {
                // contenu unique, créer un noeud
                if($contenu['contenu']!=""){
                    $elem = $doc->createElement( $tag );
                    $elem->appendChild(
                        $doc->createTextNode( $contenu['contenu'] )
                    );
                    $item->appendChild( $elem );
                }
            }
        }
        $doc->appendChild( $item );

        fix_exists_dir(CHEMIN.DOSSIER_XML);
        $r=$doc->save($this->fichier);
        if($r==true){
            $this->messages[]="enregistrement réussi de ".$this->fichier;
        } else {
            $this->messages[]="échec de l'enregistrement de ".$this->fichier;
        }
    }

    // reçoit toute le contenu dans un array
    public function get_contenu(){
        return $this->contenu;
    }
    
    public function get_liste_pour_attribut($attribut,$valeur,$exclude){
        $retour=array();
        foreach($this->contenu as $tag => $contenu){
            //print_r($contenu['@attributes']); 
            if(isset($contenu['@attributes'][$attribut]) && !in_array($tag,$exclude)){
                if($contenu['@attributes'][$attribut]==$valeur){
                    $retour[]=$tag;
                }
            }
        }
        return $retour;
    }
    // renvoir le contenu total d'un tag
    public function get_contenu_tag($tag){
        //$retour=$this->contenu[$tag]["@attributes"];
        $this->contenu[$tag];
        //return $retour;
    }
    public function get_tag_attribute($tag,$attribute,$defaut=""){
        //print_r($this->contenu[$tag]['@attributes']);
        if(isset($this->contenu[$tag]['@attributes'][$attribute])){
            return $this->contenu[$tag]['@attributes'][$attribute];
            //echo "il y a attribut";
        } else {
            return $defaut;   
        }
        //return $retour;
    }
    // renvoir le contenu d'un tag
    public function get($tag, $defaut=""){
        $retour="";
        if(isset($this->contenu[$tag])){
            // attention un tag peut être présent mais vide
            // dans ce cas il se présente en array
            if(!is_array($this->contenu[$tag]['contenu'])){
                $retour=$this->contenu[$tag]['contenu'];
            } else {
                if(count($this->contenu[$tag]['contenu'])){
                    $retour = $this->contenu[$tag]['contenu'];
                }
            }
        } 
        if($retour==""){ return $defaut; } else {
            return $retour;
        }
    }
    // renvoie le nombre d'éléments contenus
    public function get_tag_nb($tag){
        if(!isset($this->contenu[$tag]) || !isset($this->contenu[$tag]['contenu'])){
            return 0;
        }
        if(is_string($this->contenu[$tag]['contenu'])){
            return 1;
        }
        return count($this->contenu[$tag]['contenu']);
    }

    public function set($tag, $contenu){
        if(isset($this->contenu[$tag])){
            $this->contenu[$tag]['contenu']=$contenu;
        }
    }

    // Creation du formulaire
    /*
    <form>
  <div class="form-group">
    <label for="exampleInputEmail1">Email address</label>
    <input type="email" class="form-control" id="exampleInputEmail1" aria-describedby="emailHelp" placeholder="Enter email">
    <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone else.</small>
  </div>
    */
    public function deployer_formulaire($action=array()){
        // action : action= nom de l'action, bouton=texte du bouton, titre=entete
        // entete du formulaire
        $this->form="<div class='px-3'>";
        if(isset($action['titre'])){
            $this->form .= "<header>\n<h2 class='h5 mb-3'>".$action['titre']."</h2>\n</header>\n";
        }
        if(isset($action['addtop'])){
            $this->form .= $action['addtop'];
        }

        $this->form .="<form method=\"post\" enctype=\"multipart/form-data\" class=\"pb-3\">";
        $this->form .="<input type=\"hidden\" name=\"action\" value=\"".$action['action']."\" >";
        //print_r($this->contenu);
        // c'est parti !
        foreach($this->contenu as $nom => $champ){

            // champs à exclure sur demande
            if(isset($action['exclure_champ'])){
                if(in_array($nom,$action['exclure_champ'])){
                    continue;
                }
            }

            if(isset($champ['@attributes']['multiple'])) {
                $multiple=true;
                // $this->form .= "Multiple";
            } else {
                // $this->form .= "Pas multiple";
                $multiple=false;
            }

            $this->form .= "<fieldset class='form-group mb-3 ".$this->type." fieldset-".$nom."'>\n";
            $this->form .="<label for='".$nom."' class='mb-1'>".$champ['@attributes']['titre']."</label>\n";

            // soit c'est un champ multiple
            // afficher les contenus doc ou texte s'ils existent
            // afficher le form pour file ou image
            // afficher le +

            // soit c'est un champ unique
            // alors afficher le contenu image ou texte s'il existe
            // en cas d'image ou fichier, afficher le form

            if($multiple){
                // champ multiple
                $this->form .="<div class='file-item multiple small row'>\n";

                // toujours fournir un array: convertir string vers array
                if(is_string($champ['contenu'])){
                    $champ['contenu']=array( 0 => $champ['contenu']);
                }

                if(!empty($champ['contenu'])){
                    foreach($champ['contenu'] as $num => $array_elem){
                        $tvalue=$champ['contenu'][$num];
                        $tchamp=$champ;
                        $tchamp['contenu']=$tvalue;

                        switch($champ['@attributes']['type']) {
                            case 'image':
                                $this->form .= $this->form_part_image($nom, $tchamp, $multiple);
                                break;
                            case 'file':
                                $this->form .= $this->form_part_file($nom, $tchamp, $multiple);
                                break;
                            default:
                                $this->form .= $this->form_part_input($nom, $tchamp, $multiple);
                                break;
                        }
                    }
                }
                // champ vide pour les files et images
                if($champ['@attributes']['type']=='file' || $champ['@attributes']['type']=='image'){
                    $this->form .= "<div class='col-12 mb-1' data-form-base='form_".$nom."' ><input class='form-control form-control-sm' type='file' name='".$nom."[]' value=''></div>";  
                } 

                // le bouton "plus"
                $this->form .= "<div class='col-12 mb-1'><button onclick='form_input_duclicate(this);return false;' class='button bouton-plus' data-duplicate='form_$nom'>+</button></div>\n";
                $this->form .="</div>\n";

            } else {
                // champ unique !
                $this->form .="<div class='file-item unique row'>\n";

                switch($champ['@attributes']['type']) {
                    case 'image':
                        $this->form .= $this->form_part_image($nom, $champ, $multiple);
                        // afficher le form vide si rien à afficher
                        if(empty($champ['contenu'])){
                            $this->form .= "<div class='col-12 mb-1'><input class='form-control form-control-sm' type='file' name='".$nom."' value=''></div>";  
                        }
                        break;

                    case 'file':
                        $this->form .= $this->form_part_file($nom, $champ, $multiple);
                        // afficher le form vide si rien à afficher
                        if(empty($champ['contenu'])){
                            $this->form .= "<div class='col-12 mb-1'><input class='form-control form-control-sm' type='file' name='".$nom."' value=''></div>";  
                        }
                        break;

                    default:
                        $this->form .= $this->form_part_input($nom, $champ, $multiple);
                        break;
                }
                $this->form .="</div>\n";
            }
            $this->form .= "</fieldset>\n";
        }

        if(!isset($action['no_submit'])){
            $this->form .= "<input type=\"submit\" class=\"btn btn-success btn-sm\" name=\"submit\" value=\"";

            if(isset($action['submit'])){
                $this->form .=$action['submit'];
            } else {
                $this->form .= "Envoyer";
            }
            $this->form .= "\">\n";
        }

        $this->form .= "</form>\n";

        if(isset($action['delete'])){
            $this->form .= "<form method=\"post\">";
            $this->form .="<input type=\"hidden\" name=\"action\" value=\"supprimer\" >";
            $this->form .="<div id=\"supprimer_1\" class=\"btn btn-danger btn-sm mr-2\" onclick=\"show_next(this);\">Supprimer</div>";

            $this->form .= "<input type=\"submit\" class=\"btn btn-danger btn-sm\" style=\"display:none;\" name=\"supprimer\" value=\"Confirmer la suppression\">";

            $this->form .= "</form>";
        }

        $this->form.="</div>";

        if(isset($action['addbottom'])){
            $this->form .= $action['addbottom'];
        }
        return $this->form;
    }

    private function form_part_image($nom, $champ,$multiple){
        $code="";
        if($multiple){ $add="[]"; $addclass="col-12 col-sm-6 mb-1";} else { $add="";$addclass="col-12"; }
        if(!empty($champ['contenu'])) {

            $ext = pathinfo(DOSSIER_FICHIERS.$champ['contenu'], PATHINFO_EXTENSION);
            switch ($ext){
                case 'jpg':
                case'gif':
                case 'png':
                    $url_item="";
                    $code .="<div class='form-image $addclass'>";
                    $code .=  "<img src='".donne_lien( DOSSIER_FICHIERS.$champ['contenu'],$l_vignette=600,$h_vignette=400,false)."' data-original='".$champ['contenu']."' class='force-w px-0'>";
                    $code .=  "<div class='tools-image item-tools' data-item='".$url_item."'>";
                    $code .= "<button class=' button'  onclick='image_rotate(\"".$champ['contenu']."\",90,\"".$url_item."\");'><i class='fas fa-undo-alt' class='icon-rotate'></i></button><button class='button' onclick='image_rotate(\"".$champ['contenu']."\",-90,\"".$url_item."\");' class='icon-rotate'><i class='fas fa-redo-alt'></i></button>";
                    $code .="<input type='checkbox' name='doc-delete[]' id='".$nom."|".$champ['contenu']."' value='".$nom."|".$champ['contenu']."' class='d-none'><label for='".$nom."|".$champ['contenu']."' class='icon-delete carefull button' onClick='visible_check(this);'><i class='fas fa-times'></i></label>";
                    $code .=  "</div></div>";
                    break;
            }
        }

        return $code;
    }

    private function form_part_file($nom, $champ,$multiple){
        $code="";
        if($multiple){ $add="[]"; } else { $add=""; }
        if(!empty($champ['contenu'])) {
            // creer un hash pour placer dans le value le type et le nom
            // pour un meilleur process
            $ext = pathinfo(DOSSIER_FICHIERS.$champ['contenu'], PATHINFO_EXTENSION);
            $icones=array(
                "pdf"=>"far fa-file-pdf",
                "zip" =>"far fa-file-archive",
                "defaut" => "far fa-file"
            );

            if(isset($icones[$ext])){
                $icon_class=$icones[$ext];
            } else {
                $icon_class=$icones['defaut'];
            }

            $code .= "<div class='col-12'><i class='".$icon_class." pr-1 h6' aria-hidden='true'></i><span class='pr-3 h6'>".fichier_seul(DOSSIER_FICHIERS.$champ['contenu'])."</span> <span class='tools-file'><input type='checkbox' name='doc-delete[]' value='".$nom."|".$champ['contenu']."' id='".$nom."|".$champ['contenu']."' class='d-none'><label for='".$nom."|".$champ['contenu']."' class='icon-delete carefull button' onClick='visible_check(this);'><i class='fas fa-times'></i></label></span></div>";
        }

        return $code;
    }

    // sous fonction de déployer formulaire, crée un élément particulier
    // ancien value_html_part
    private function form_part_input($titre, $champ, $multiple=false){
        $code="";
        if(isset($champ['@attributes']['class'])) {
            $addclass=" ".$champ['@attributes']['class'];
        } else {
            $addclass="";
        }

        if($multiple){ $add="[]"; } else { $add=""; }
        switch($champ['@attributes']['type']) {
            case 'select':
                $options=explode("|",$champ['@attributes']['value']);
                $code .= "<div class='col-12 mb-1' data-form-base='form_".$titre."'><select class='form-control-sm form-control' name='".$titre.$add."'>\n";
                foreach($options as $option){
                    $code.= "<option value='".$option."'";
                    if($option == $champ['contenu']){
                        $code .=" selected='selected'";
                    }
                    $code .=">".$option."</option>\n";
                }
                $code .= "</select></div>\n";
                break;

            case 'radio':
                $options=explode("|",$champ['@attributes']['value']);
                $code .="<div class='col-12 mb-1' data-form-base='form_".$titre."'>";
                foreach($options as $option){
                    $code .= "<span class='pr-3'><input class='form-control-sm form-control mr-1' type='radio' name='".$titre.$add."' value='".$option."'";
                    if($option == $champ['contenu']){
                        $code .=" checked='checked'";
                    }
                    $code .="> ".$option."</span>\n";
                }
                $code .="</div>";
                break;

            case 'textarea':
                $code .= "<div class='col-12 mb-1' data-form-base='form_".$titre."'><textarea class='form-control-sm form-control' name='".$titre.$add."'>".$champ['contenu']."</textarea></div>\n";
                break;

            default:
                $code .= "<div class='col-12 mb-1' data-form-base='form_".$titre."'><input class='form-control-sm form-control $addclass' type='text' name='".$titre.$add."' value='".$champ['contenu']."'></div>\n";
                break;
        }

        return $code;
    }

    public function traiter_formulaire($ecrire=false){
        //unset($_POST['valider']);
        $retour="none";
        //print_r($_POST);
        if(isset($_POST['action'])){

            if($_POST['action']=="supprimer"){
                $this->supprimer_xml();
                return "delete";
            }
            // d'abord les suppressions de document
            // virer les docs, puis les virer du $_POST
            // ici il faudrait checker si il y a suppression de document. 
            // les documents sont signalé par un bouton checkbox avec leur nom
            // les supprimer avant toute chose et les retirer de la liste de $this->contenu

            //print_r($_POST); 
            $retour="update";

            // ne pas injecter le bouton du form dans le xml !
            unset($_POST['action']);
            unset($_POST['submit']); // bouton du form, pas utile

            // traitement des fichiers à supprimer
            $this->traiter_uploads_delete();

            foreach($_POST as $cle => $valeur){
                // pre-traitement: soit c'est un champ unique,
                // du coup passer l'array éventuel à champ
                // soit c'est un multiple, vider les elements de liste vides
                if(isset($this->contenu[$cle]['@attributes']['multiple'])) {
                    if(is_array($valeur)){
                        for($i=count($valeur)-1;$i>=0;$i--){
                            if(empty($valeur[$i])){
                                unset($valeur[$i]); // virer si c'est vide
                            }
                        }
                    }
                } else {
                    if(is_array($valeur)){
                        $valeur=$valeur[0]; // ne prendre que le premier
                    }
                }

                //if(!empty($valeur) && !is_array($valeur)){
                $this->contenu[$cle]['contenu']=$valeur;
                //}
                // supprimer cette clé du contenu
                // pour pouvoir dans un deuxième temps
                // ajouter les contenus éventuellement ajoutés librement 
                // sans référence dans la définition du xml
                unset($_POST[$cle]);
            }

            $this->traiter_uploads();

            // si c'est un nouveau xml, lui donner un nom
            if($this->hydrate==false){
                $this->fichier=CHEMIN.DOSSIER_XML.date("YmdHis")."_".$this->nettoie_lien($this->get('titre'))."_".hash('adler32', date("Y-m-d H:i:s")).".xml";
                $this->fichier_seul=fichier_seul($this->fichier);
                $retour="insert";
            }

            if($ecrire){
                $this->ecrit_xml();
            }
        }
        return $retour;
    }

    // supprimer les fichiers demandés
    private function traiter_uploads_delete(){


        if(isset($_POST['doc-delete'])){
            foreach($_POST['doc-delete'] as $num => $doc){
                $elem=explode("|",$doc);
                // rechercher le bon element
                // si c'est un contenu unique (pas un array, supprimer l'élément)
                if(!is_array($this->contenu[$elem[0]]['contenu'])){
                    unset($this->contenu[$elem[0]]);
                    @unlink(CHEMIN.DOSSIER_FICHIERS.$elem[1]);
                } else {
                    // plusieurs éléments dans contenu !
                    for($i = count($this->contenu[$elem[0]]['contenu'])-1; $i>=0;$i--){
                        if($this->contenu[$elem[0]]['contenu'][$i]==$elem[1]){
                            unset($this->contenu[$elem[0]]['contenu'][$i]);
                            @unlink(CHEMIN.DOSSIER_FICHIERS.$elem[1]);
                            $this->contenu[$elem[0]]['contenu'] = array_values($this->contenu[$elem[0]]['contenu']);
                        }
                    }
                }
            }
            unset ($_POST['doc-delete']);
        }
    }
    // traiter les imports de fichier
    // hydrate contenu avec 
    private function traiter_uploads(){
        // ne pas oublier de virer les documents supprimés
        fix_exists_dir(CHEMIN.DOSSIER_FICHIERS);

        foreach($_FILES as $tag => $infos){
            //echo "<hr>Je prend file $tag";
            if($this->contenu[$tag]['@attributes']['type']=='file' || $this->contenu[$tag]['@attributes']['type']=='image'){ // peut-on associer un fichier à ce tag
                $ext_ok=explode(",",$this->contenu[$tag]['@attributes']['allow']);

                // okay, on passe en revue les files
                // si ils correspondent à un élément de form, et à son extension
                // soit il est unique et on vérifie qu'il n'existe pas déjà
                // soit c'est un multiple et on l'ajoute
                if(is_array($infos['name'])){ // element multiple
                    foreach($infos['name'] as $num => $liste){

                        $ext = pathinfo($infos['name'][$num], PATHINFO_EXTENSION);
                        $this->traiter_un_upload($tag,$ext, $ext_ok,
                                                 $infos['name'][$num],
                                                 $infos['tmp_name'][$num],
                                                 $infos['size'][$num],
                                                 true // multiple
                                                );
                    }
                } else { // element unique
                    $ext = pathinfo($infos['name'], PATHINFO_EXTENSION);
                    $this->traiter_un_upload($tag,$ext,$ext_ok,
                                             $infos['name'],
                                             $infos['tmp_name'],
                                             $infos['size'],
                                             false // unique
                                            );
                }
            }
        }
    }

    private function traiter_un_upload($tag,$ext,$ext_ok,$name,$tmp_name,$size,$multiple){
        if(in_array($ext,$ext_ok) && !empty($name)){
            $name=$name;
            $tempFile = $tmp_name;
            $size= $size;
            $fileParts = pathinfo($name);

            $nom_seul=$this->stripAccents($fileParts['filename']);
            if(file_exists(CHEMIN.DOSSIER_FICHIERS.$nom_seul.".".$ext)){
                $ad= hash('adler32', date("Y-m-d H:i:s"));
                $nom_seul=$nom_seul."_".$ad; // ce serait mieux entre le nom et l'extension
            }

            // attention : les fichiers sont toujours entrés dans un array, 
            // pour des raisons d'uniformité
            if(move_uploaded_file($tempFile, CHEMIN.DOSSIER_FICHIERS.$nom_seul.".".$ext)){

                // recuperer les contenus précédents en array
                // le contenu à la base peut être vide, ou ne contenir qu'un élément en string
                if(!is_array($this->contenu[$tag]['contenu'])){
                    if(!empty($this->contenu[$tag]['contenu'])){
                        $this->contenu[$tag]['contenu']=array($this->contenu[$tag]['contenu']);
                    } else {
                        $this->contenu[$tag]['contenu']=array(); 
                    }
                }

                if($multiple){
                    $this->contenu[$tag]['contenu'][]=$nom_seul.".".$ext; 
                } else {
                    $this->contenu[$tag]['contenu']=$nom_seul.".".$ext;
                }
                $this->messages[]="fichier envoyé avec succès vers ".DOSSIER_FICHIERS;

            } else {
                $this->messages[]="Impossible de déplacer le fichier vers ".DOSSIER_FICHIERS;
            }
        } else {
            $this->messages[]="- Extension non compatible : $ext pas dans ".$this->contenu[$tag]['@attributes']['allow']." ou fichier absent<br>";
        }
    }

    public function supprimer_xml(){
        // supprimer le xml
        //echo "supprimer ".$this->fichier;
        unlink($this->fichier);

        // supprimer les documents attachés
        foreach($this->get_contenu() as $elem){
            if($elem['@attributes']['type']=="file" || $elem['@attributes']['type']=="image"){
                $c=$elem['contenu'];
                if(!is_array($c)){$c=array($c);}
                foreach($c as $f){
                    if($f){
                        unlink(CHEMIN.DOSSIER_FICHIERS.$f);
                    }
                    if($elem['@attributes']['type']=="image"){
                        // eliminer les vignettes de l'image !
                    }
                }

            }
        }

    }
    /*

        Petites fonctions diverses - - - - - - -  -


*/
    // transforme un lien en un truc uniquement constitué de lettres
    public function nettoie_lien($texte){
        $texte = preg_replace("#[^a-zA-Z]#", "", $texte);
        return $texte;
    }
    // retire tous les caractères qui peuvent poser problème à l'enregistrement
    public function stripAccents($string){
        $str = htmlentities($string, ENT_NOQUOTES, 'UTF-8');
        $str = preg_replace('#\&([A-za-])(?:acute|cedil|circ|grave|ring|tilde|uml)\;#', '\1', $str);
        $str = strtolower(str_replace(" ","_",$str));
        $str = str_replace(array("#","'",'"'),"",$str);
        return $str;
    }


}
?>