<?php

/*
Fonctions d'affichage générales
en latéral ou frontal

Charger le fichier de surcharge éventuel
*/
if(file_exists(CHEMIN.DOSSIER_CUSTOM."custom-functions.php")){
    include(CHEMIN.DOSSIER_CUSTOM."custom-functions.php");
}
// afficher le contenu des pages (fichiers xml de contenus situées dans config/custom)
function display_page($page,$url){
    echo "<div class='p-3'>";
    echo display_buttons("edit_page('".$url."')",true); 
    echo "<h3 class=\"titre-small mb-2\">".$page["titre"]."</h3>";
    echo "<div class=\"texte\">";
    echo $page["texte"];
    echo "</div>";
    echo "</div>";
}

// affiche chaque item dans la galerie générale
function display_mosaique_item($xml,$return=false){
    if(function_exists('display_mosaique_item_custom')){
        $item = display_mosaique_item_custom($xml,$return);
        if($return){
            return $item;
        } else {
            echo $item;
        }
    } else {
        $item = "<article class=\"col-12 col-sm-6 col-md-4 col-lg-3 col-xl-2 mb-3 item\" data-xml=\"".$xml->fichier_seul."\" data-mainillu=\"".$xml->get("illustration", "images/defaut.jpg")."\">\n";
        $item .= "<div class=\"mb-2\" onclick=\"item_click(this)\">\n";
        $item .= "<img class=\"img-fluid item-illu\" src=\"";
        $item .= donne_lien(DOSSIER_FICHIERS.$xml->get("illustration", "images/defaut.jpg"),ILLU_WIDTH,ILLU_HEIGHT,true);
        $item .= "\" alt=\"\">\n";
        $item .= "</div>\n";
        
        $l=$xml->get_liste_pour_attribut("afficher","oui",array("illustration"));
        foreach($l as $tag){
            $item .= "<div class=\"tag-$tag\" data-contenu=\"$tag\">".flat_array($xml->get($tag))."</div>\n";
        }
        $item .= "</article>\n";
        if($return){
            return $item;
        } else {
            echo $item;
        } 
    }
}

// affiche le contenu d'un xml dans l'espace latéral
function display_lateral_item($xml,$return=false){
    if(function_exists('display_lateral_item_custom')){
        $item = display_lateral_item_custom($xml,$return);
    } else {
        echo "<div class='px-3'>";
        echo display_buttons("item_edit('".$xml->fichier_seul."')",true);
        echo "<div class='viewer-main-illu-container'>";
        $original=donne_lien(DOSSIER_FICHIERS.$xml->get("illustration", "images/defaut.jpg"),1200,1200,false);
        echo "<img class=\"img-fluid viewer-main-illu\" src=\"";
        echo $original;
        echo "\" alt=\"\" data-original=\"".$original."\">\n";
        echo "<div class=\"button button-back\" onclick=\"viewer_back_image();\"><i class=\"fas fa-arrow-left\"></i></div>";
        echo "</div>";
        foreach($xml->get_contenu() as $tag => $tag_contenu){
            if($tag_contenu['contenu']){
                if($tag =="illustration"){
                    continue;
                }
                if($tag_contenu['@attributes']['type']=='image'){
                    display_images($xml,$tag);
                } else  if($tag_contenu['@attributes']['type']=='file'){
                    display_files($xml,$tag);
                } else {
                    echo "<div class='".$xml->get_tag_attribute($tag,"class","texte-mini mb-2")."' title='".$tag_contenu['@attributes']['titre']."'>".nl2br(flat_array($tag_contenu['contenu']))."</div>";  
                }
            } 
        } 
        echo "</div>";
    }
}

// affiche la fiche complète en pleine page
function display_fullpage_item($xml){
    if(function_exists('display_fullpage_item_custom')){
        display_fullpage_item_custom($xml);
    } else {
        echo "<article class=\"row mx-0 h-100\">";
        echo "<div class=\"col-12 col-sm-9 p-0 p-md-3 mb-3 h-100 text-center\">\n";
        $original=donne_lien(DOSSIER_FICHIERS.$xml->get("illustration", "images/defaut.jpg"),1200,1200,false);
        echo "<img class=\"img-fluid viewer-main-illu\" src=\"";
        echo $original;
        echo "\" alt=\"\" data-original=\"".$original."\">\n";
        echo "<div class=\"button button-back\" onclick=\"viewer_back_image();\"><i class=\"fas fa-arrow-left\"></i></div>";
        echo "</div>\n";
        echo "<div class='col-12 col-sm-3 p-0 pt-md-3 pr-md-3 mb-3 h-100'><div class='border-left pl-3 h-100'>";
        echo display_buttons("item_edit('".$xml->fichier_seul."')",true);
        echo "<div class='mt-3'>";
        foreach($xml->get_contenu() as $tag => $tag_contenu){
            if($tag_contenu['contenu']){
                if($tag =="illustration"){
                    continue;
                }
                echo "<div class='viewer-$tag'>";
                if($tag_contenu['@attributes']['type']=='image'){
                    display_images($xml,$tag);
                } else  if($tag_contenu['@attributes']['type']=='file'){
                    display_files($xml,$tag);
                } else {
                    echo "<div class='".$xml->get_tag_attribute($tag,"class","texte-mini mb-2")."' title='".$tag_contenu['@attributes']['titre']."'>".nl2br(flat_array($tag_contenu['contenu']))."</div>";  
                }
                echo "</div>";
            }
        }
        echo "</div><div></div>"; 
        echo "<script>init_fullpage();</script>";
        echo "</article>";
    }
}
// affiche l'image et le titre en pleine page
function display_galerie_item($xml){
    if(function_exists('display_galerie_item_custom')){
        display_galerie_item_custom($xml);
    } else {
        echo display_buttons("item_edit('".$xml->fichier_seul."')",false);
        echo "<img src=\"";
        echo donne_lien(DOSSIER_FICHIERS.$xml->get("illustration", "images/defaut.jpg"),1200,800,false);
        echo "\" class=\"\"></div><div class=\"item-info\"><div>";
        echo $xml->get("titre");
        echo "</div></div>";
    }
}

// sous fonction d'affichage des images en latéral ou pleine page
function display_images($xml,$tag){
    $nb=$xml->get_tag_nb($tag);
    if($nb ==1){
        echo "<img onlick='viewer_show_image(this);' class='force-w mb-2' src='";
        echo donne_lien(DOSSIER_FICHIERS.$xml->get($tag, "images/defaut.jpg"), ILLU_WIDTH, ILLU_HEIGHT, false);
        echo "' data-original='".donne_lien(DOSSIER_FICHIERS.$xml->get($tag, "images/defaut.jpg"),1200,1200,false)."'>";
    }
    if($nb >1){
        echo "<h2 class='small'>".$xml->get_tag_attribute($tag,"titre")."</h2>";
        echo "<div class='viewer-grid-images mb-2'>";
        foreach($xml->get($tag) as $im){
            echo "<div class='viewer-grid-image'><img onclick='viewer_show_image(this);' class='img-fluid' src='";
            echo donne_lien(DOSSIER_FICHIERS.$im, 600, 400, true);
            echo "' data-original='".donne_lien(DOSSIER_FICHIERS.$im,1200,1200,false)."'></div>";
        }
        echo "</div>";
    }
}

// sous-fonction d'affichage des fichiers en latéral ou pleine page
function display_files($xml,$tag){
    echo "<div class='my-2 pt-2 border-top'>";
    echo "<h2 class='small'>".$xml->get_tag_attribute($tag,"titre")."</h2>";
    $nb=$xml->get_tag_nb($tag);
    $tag_contenu=$xml->get($tag);
    if($nb ==1){
        echo "<div class='".$xml->get_tag_attribute($tag,"class","texte-mini mb-1")."' title='".$xml->get_tag_attribute($tag,"titre")."'><a href='".DOSSIER_FICHIERS.$tag_contenu."'>".file_icon($tag_contenu).fichier_seul($tag_contenu)."</a></div>"; 
    }
    if($nb >1){
        //echo "<div class='row'>";

        foreach($xml->get($tag) as $im){
            echo "<div class='".$xml->get_tag_attribute($tag,"class","texte-mini mb-1")."' title='".$xml->get_tag_attribute($tag,"titre")."'><a href='".DOSSIER_FICHIERS.$im."'>".file_icon($im).fichier_seul($im)."</a></div>"; 
        }
        //echo "</div>";
    }
    echo "</div>";
}

// affichage des boutons avant-après-edit-close
function display_buttons($url,$edit=false){
    $buttons="<div class=\"container-buttons\">";
    $buttons .="<div class=\"buttons-left\">";
    $buttons .="<div class=\"button button-prev\" onclick=\"item_precedent();\"><i class=\"fas fa-chevron-left\"></i></div>";
    $buttons .="<div class=\"button button-next\" onclick=\"item_suivant();\"><i class=\"fas fa-chevron-right\"></i></div>";
    if((isset($_SESSION['login']) || DEBUG) && $edit==true){
        $buttons .="<div class=\"button button-edit\" onclick=\"".$url."\"><i class=\"fas fa-pencil-alt\"></i></div>";
    }
    $buttons .="</div><div class=\"buttons-right\">";
    $buttons .="<div class=\"button button-full\" onclick=\"openFullscreen();\"><i class=\"fas fa-expand\"></i></div>";
    $buttons .="<div class=\"button button-close\" onclick=\"close_viewer();\"><span class=\"titre-tiny\">Close</span> <i class=\"fas fa-chevron-right\"></i></div></div></div>"; 
    return $buttons; 
}

// sous-fonction : associer une icone à un type fichier
function file_icon($fichier){
    $icones=array(
        "pdf"=>"far fa-file-pdf",
        "zip" =>"far fa-file-archive",
        "tif"=>"far fa-file-image",
        "defaut" => "far fa-file",
    );
    $ext = pathinfo($fichier, PATHINFO_EXTENSION);
    if(isset($icones[$ext])){
        $icon_class=$icones[$ext];
    } else {
        $icon_class=$icones['defaut'];
    }
    return "<i class=\"".$icon_class." pr-1\"></i>";
}

function flat_array($c,$glu=", "){
    if(is_array($c)){
        $c=implode($glu,$c);
    }
    return $c;
}
?>